import * as firebaseOriginal from 'firebase/app';
import UserCredential = firebase.auth.UserCredential;
import * as firebaseuiOriginal from '@speakylink/firebaseui';
export declare const firebase: typeof firebaseOriginal;
export declare const firebaseui: typeof firebaseuiOriginal;
export declare type NativeFirebaseUIAuthConfig = firebaseuiOriginal.auth.Config;
export declare class FirebaseUISignInSuccessWithAuthResult {
    authResult: UserCredential;
    redirectUrl: string;
}
export declare class FirebaseUISignInFailure {
    code: string;
    credential: firebaseOriginal.auth.AuthCredential;
}
